Index: drivers/video/aty/atyfb_base.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/aty/atyfb_base.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/aty/atyfb_base.c	22 Jul 2004 19:50:23 -0000	1.1
+++ drivers/video/aty/atyfb_base.c	4 Aug 2004 01:29:59 -0000	1.2
@@ -1046,125 +1274,185 @@
      */
 
 static int atyfb_get_var(struct fb_var_screeninfo *var, int con,
-			 struct fb_info *fb)
+                         struct fb_info *fb)
 {
     const struct fb_info_aty *info = (struct fb_info_aty *)fb;
 
     if (con == -1)
-	atyfb_encode_var(var, &info->default_par, info);
+        atyfb_encode_var(var, &info->default_par, info);
     else
-	*var = fb_display[con].var;
+        *var = fb_display[con].var;
     return 0;
 }
 
 
 static void atyfb_set_dispsw(struct display *disp, struct fb_info_aty *info,
-			     int bpp, int accel)
+                             int bpp, int accel)
 {
-	    switch (bpp) {
+            switch (bpp) {
 #ifdef FBCON_HAS_CFB8
-		case 8:
-		    info->dispsw = accel ? fbcon_aty8 : fbcon_cfb8;
-		    disp->dispsw = &info->dispsw;
-		    break;
+                case 8:
+                    info->dispsw = accel ? fbcon_aty8 : fbcon_cfb8;
+                    disp->dispsw = &info->dispsw;
+                    break;
 #endif
 #ifdef FBCON_HAS_CFB16
-		case 16:
-		    info->dispsw = accel ? fbcon_aty16 : fbcon_cfb16;
-		    disp->dispsw = &info->dispsw;
-		    disp->dispsw_data = info->fbcon_cmap.cfb16;
-		    break;
+                case 16:
+                    info->dispsw = accel ? fbcon_aty16 : fbcon_cfb16;
+                    disp->dispsw = &info->dispsw;
+                    disp->dispsw_data = info->fbcon_cmap.cfb16;
+                    break;
 #endif
 #ifdef FBCON_HAS_CFB24
-		case 24:
-		    info->dispsw = accel ? fbcon_aty24 : fbcon_cfb24;
-		    disp->dispsw = &info->dispsw;
-		    disp->dispsw_data = info->fbcon_cmap.cfb24;
-		    break;
+                case 24:
+                    info->dispsw = accel ? fbcon_aty24 : fbcon_cfb24;
+                    disp->dispsw = &info->dispsw;
+                    disp->dispsw_data = info->fbcon_cmap.cfb24;
+                    break;
 #endif
 #ifdef FBCON_HAS_CFB32
-		case 32:
-		    info->dispsw = accel ? fbcon_aty32 : fbcon_cfb32;
-		    disp->dispsw = &info->dispsw;
-		    disp->dispsw_data = info->fbcon_cmap.cfb32;
-		    break;
-#endif
-		default:
-		    disp->dispsw = &fbcon_dummy;
-	    }
+                case 32:
+                    info->dispsw = accel ? fbcon_aty32 : fbcon_cfb32;
+                    disp->dispsw = &info->dispsw;
+                    disp->dispsw_data = info->fbcon_cmap.cfb32;
+                    break;
+#endif
+                default:
+                    disp->dispsw = &fbcon_dummy;
+            }
 #ifdef CONFIG_FB_ATY_CT
-	    if (info->cursor) {
-		info->dispsw.cursor = atyfb_cursor;
-		info->dispsw.set_font = atyfb_set_font;
-	    }
+            if (info->cursor) {
+                info->dispsw.cursor = atyfb_cursor;
+                info->dispsw.set_font = atyfb_set_font;
+            }
 #endif /* CONFIG_FB_ATY_CT */
 }
 
+    /*
+     * In the display mode set code we need to make desisions depending on
+     * wether the LCD or CRT monitor is enabled.
+     * This is going to give problems in the unlikely case that someone
+     * for example turns on the LCD monitor just after we tested what
+     * monitors are enabled. Since the consequences are very serious
+     * (the graphic card crashes and sends the wrong signals to the lcd
+     *  monitor which gets brighter and brighter; to prevent it from
+     * damage the computer must be switched off as soon as possible)
+     * we need to prevent this.
+     *
+     * As far as I know there is no way to prevent people switching on the
+     * LCD monitor while we are programming the video card. So the best way
+     * to do it, is detect what monitors are enabled before programming the
+     * video chip. After programming the video chip, we write this information
+     * back to the video chip, switching the LCD off again if someone enabled
+     * it. But isn't the card already crashed before we have the chance to
+     * turn the display back off? I don't think so because the CRTC is disabled
+     * while we program it.
+     */
+
+#ifdef CONFIG_FB_ATY_GENERIC_LCD
+static u32 atyfb_monitors_enabled(struct fb_info_aty *info) {
+     if (info->lcd_table != 0) {
+         return aty_ld_lcd(LCD_GEN_CTRL, info) & 3;
+     };
+     return 0;
+};
+#else
+#define atyfb_monitors_enabled(info) 0
+#endif
 
     /*
      *  Set the User Defined Part of the Display
      */
 
 static int atyfb_set_var(struct fb_var_screeninfo *var, int con,
-			 struct fb_info *fb)
+                         struct fb_info *fb)
 {
     struct fb_info_aty *info = (struct fb_info_aty *)fb;
     struct atyfb_par par;
     struct display *display;
     int oldxres, oldyres, oldvxres, oldvyres, oldbpp, oldaccel, accel, err;
     int activate = var->activate;
+    u32 monitors_enabled;
 
     if (con >= 0)
-	display = &fb_display[con];
+        display = &fb_display[con];
     else
-	display = fb->disp;	/* used during initialization */
+        display = fb->disp;     /* used during initialization */
+
+    monitors_enabled = atyfb_monitors_enabled(info);
+
+    /*
+     * We have to be very carefull with encode_var for LCD_panels. Fbdev
+     * applications do not know about LCD monitors. We have to make them
+     * think they are using a CRT. That means that alltough the video
+     * chip is programmed for the resolution of the LCD monitor (say 800x600),
+     * the applications expect the mode they asked for, say 640x480
+     *
+     * So when a program asks for 640x480, atyfb_decode_var sets the crtc
+     * registers for 800x600. Then atyfb_encode_var calculates the crtc
+     * registers back into the var variable, but now the var variable
+     * will contain wrong values for 800x600! Result: wrong information is
+     * returned to the program!
+     *
+     * To counter this, we call atyfb_decode_var first like if there is no
+     * lcd monitor switched on. Then we call atyfb_decode_var. Now
+     * the correct information is returned to the program, but the values
+     * for the crtc registers are not suited for the LCD monitor. We call
+     * atyfb_decode_var again to calculate the registers again, this time
+     * with the right monitors_enabled.
+     */
 
-    if ((err = atyfb_decode_var(var, &par, info)))
-	return err;
+    if ((err = atyfb_decode_var(var, &par, info, CRT_ON)))
+        return err;
 
     atyfb_encode_var(var, &par, (struct fb_info_aty *)info);
 
+#ifdef CONFIG_FB_ATY_GENERIC_LCD
+    if ((err = atyfb_decode_var(var, &par, info, monitors_enabled)))
+        return err;
+#endif
+
     if ((activate & FB_ACTIVATE_MASK) == FB_ACTIVATE_NOW) {
-	oldxres = display->var.xres;
-	oldyres = display->var.yres;
-	oldvxres = display->var.xres_virtual;
-	oldvyres = display->var.yres_virtual;
-	oldbpp = display->var.bits_per_pixel;
-	oldaccel = display->var.accel_flags;
-	display->var = *var;
-	accel = var->accel_flags & FB_ACCELF_TEXT;
-	if (oldxres != var->xres || oldyres != var->yres ||
-	    oldvxres != var->xres_virtual || oldvyres != var->yres_virtual ||
-	    oldbpp != var->bits_per_pixel || oldaccel != var->accel_flags) {
-	    struct fb_fix_screeninfo fix;
-
-	    encode_fix(&fix, &par, info);
-	    display->screen_base = (char *)info->frame_buffer;
-	    display->visual = fix.visual;
-	    display->type = fix.type;
-	    display->type_aux = fix.type_aux;
-	    display->ypanstep = fix.ypanstep;
-	    display->ywrapstep = fix.ywrapstep;
-	    display->line_length = fix.line_length;
-	    display->can_soft_blank = 1;
-	    display->inverse = 0;
-	    if (accel)
-	    	display->scrollmode = (info->bus_type == PCI) ? SCROLL_YNOMOVE : 0;
-	    else
-	    	display->scrollmode = SCROLL_YREDRAW;
-	    if (info->fb_info.changevar)
-		(*info->fb_info.changevar)(con);
-	}
-	if (!info->fb_info.display_fg ||
-	    info->fb_info.display_fg->vc_num == con) {
-	    atyfb_set_par(&par, info);
-	    atyfb_set_dispsw(display, info, par.crtc.bpp, accel);
-	}
-	if (oldbpp != var->bits_per_pixel) {
-	    if ((err = fb_alloc_cmap(&display->cmap, 0, 0)))
-		return err;
-	    do_install_cmap(con, &info->fb_info);
-	}
+        oldxres = display->var.xres;
+        oldyres = display->var.yres;
+        oldvxres = display->var.xres_virtual;
+        oldvyres = display->var.yres_virtual;
+        oldbpp = display->var.bits_per_pixel;
+        oldaccel = display->var.accel_flags;
+        display->var = *var;
+        accel = var->accel_flags & FB_ACCELF_TEXT;
+        if (oldxres != var->xres || oldyres != var->yres ||
+            oldvxres != var->xres_virtual || oldvyres != var->yres_virtual ||
+            oldbpp != var->bits_per_pixel || oldaccel != var->accel_flags) {
+            struct fb_fix_screeninfo fix;
+
+            encode_fix(&fix, &par, info);
+            display->screen_base = (char *)info->frame_buffer;
+            display->visual = fix.visual;
+            display->type = fix.type;
+            display->type_aux = fix.type_aux;
+            display->ypanstep = fix.ypanstep;
+            display->ywrapstep = fix.ywrapstep;
+            display->line_length = fix.line_length;
+            display->can_soft_blank = 1;
+            display->inverse = 0;
+            if (accel)
+                display->scrollmode = (info->bus_type == PCI) ? SCROLL_YNOMOVE : 0;
+            else
+                display->scrollmode = SCROLL_YREDRAW;
+            if (info->fb_info.changevar)
+                (*info->fb_info.changevar)(con);
+        }
+        if (!info->fb_info.display_fg ||
+            info->fb_info.display_fg->vc_num == con) {
+            atyfb_set_par(&par, info);
+            atyfb_set_dispsw(display, info, par.crtc.bpp, accel);
+        }
+        if (oldbpp != var->bits_per_pixel) {
+            if ((err = fb_alloc_cmap(&display->cmap, 0, 0)))
+                return err;
+            do_install_cmap(con, &info->fb_info);
+        }
     }
 
     return 0;
@@ -1178,7 +1466,7 @@
      */
 
 static int atyfb_pan_display(struct fb_var_screeninfo *var, int con,
-			     struct fb_info *fb)
+                             struct fb_info *fb)
 {
     struct fb_info_aty *info = (struct fb_info_aty *)fb;
     u32 xres, yres, xoffset, yoffset;
@@ -1189,7 +1477,7 @@
     xoffset = (var->xoffset+7) & ~7;
     yoffset = var->yoffset;
     if (xoffset+xres > par->crtc.vxres || yoffset+yres > par->crtc.vyres)
-	return -EINVAL;
+        return -EINVAL;
     par->crtc.xoffset = xoffset;
     par->crtc.yoffset = yoffset;
     set_off_pitch(par, info);
@@ -1201,15 +1489,15 @@
      */
 
 static int atyfb_get_cmap(struct fb_cmap *cmap, int kspc, int con,
-			  struct fb_info *info)
+                          struct fb_info *info)
 {
     if (!info->display_fg || con == info->display_fg->vc_num) /* current console? */
-	return fb_get_cmap(cmap, kspc, atyfb_getcolreg, info);
+        return fb_get_cmap(cmap, kspc, atyfb_getcolreg, info);
     else if (fb_display[con].cmap.len) /* non default colormap? */
-	fb_copy_cmap(&fb_display[con].cmap, cmap, kspc ? 0 : 2);
+        fb_copy_cmap(&fb_display[con].cmap, cmap, kspc ? 0 : 2);
     else {
-	int size = fb_display[con].var.bits_per_pixel == 16 ? 32 : 256;
-	fb_copy_cmap(fb_default_cmap(size), cmap, kspc ? 0 : 2);
+        int size = fb_display[con].var.bits_per_pixel == 16 ? 32 : 256;
+        fb_copy_cmap(fb_default_cmap(size), cmap, kspc ? 0 : 2);
     }
     return 0;
 }
@@ -1219,54 +1507,32 @@
      */
 
 static int atyfb_set_cmap(struct fb_cmap *cmap, int kspc, int con,
-			  struct fb_info *info)
+                          struct fb_info *info)
 {
     int err;
     struct display *disp;
 
     if (con >= 0)
-    	disp = &fb_display[con];
+        disp = &fb_display[con];
     else
         disp = info->disp;
-    if (!disp->cmap.len) {	/* no colormap allocated? */
-	int size = disp->var.bits_per_pixel == 16 ? 32 : 256;
-	if ((err = fb_alloc_cmap(&disp->cmap, size, 0)))
-	    return err;
+    if (!disp->cmap.len) {      /* no colormap allocated? */
+        int size = disp->var.bits_per_pixel == 16 ? 32 : 256;
+        if ((err = fb_alloc_cmap(&disp->cmap, size, 0)))
+            return err;
     }
-    if (!info->display_fg || con == info->display_fg->vc_num)			/* current console? */
-	return fb_set_cmap(cmap, kspc, atyfb_setcolreg, info);
+    if (!info->display_fg || con == info->display_fg->vc_num)                   /* current console? */
+        return fb_set_cmap(cmap, kspc, atyfb_setcolreg, info);
     else
-	fb_copy_cmap(cmap, &disp->cmap, kspc ? 0 : 1);
+        fb_copy_cmap(cmap, &disp->cmap, kspc ? 0 : 1);
     return 0;
 }
 
 
-#ifdef DEBUG
-#define ATYIO_CLKR		0x41545900	/* ATY\00 */
-#define ATYIO_CLKW		0x41545901	/* ATY\01 */
-
-struct atyclk {
-    u32 ref_clk_per;
-    u8 pll_ref_div;
-    u8 mclk_fb_div;
-    u8 mclk_post_div;		/* 1,2,3,4,8 */
-    u8 vclk_fb_div;
-    u8 vclk_post_div;		/* 1,2,3,4,6,8,12 */
-    u32 dsp_xclks_per_row;	/* 0-16383 */
-    u32 dsp_loop_latency;	/* 0-15 */
-    u32 dsp_precision;		/* 0-7 */
-    u32 dsp_on;			/* 0-2047 */
-    u32 dsp_off;		/* 0-2047 */
-};
-
-#define ATYIO_FEATR		0x41545902	/* ATY\02 */
-#define ATYIO_FEATW		0x41545903	/* ATY\03 */
-#endif
-
 static int atyfb_ioctl(struct inode *inode, struct file *file, u_int cmd,
-		       u_long arg, int con, struct fb_info *info2)
+                       u_long arg, int con, struct fb_info *info2)
 {
-#if defined(__sparc__) || (defined(DEBUG) && defined(CONFIG_FB_ATY_CT))
+#if defined(__sparc__)
     struct fb_info_aty *info = (struct fb_info_aty *)info2;
 #endif /* __sparc__ || DEBUG */
 #ifdef __sparc__
@@ -1274,7 +1540,7 @@
     struct display *disp;
 
     if (con >= 0)
-    	disp = &fb_display[con];
+        disp = &fb_display[con];
     else
         disp = info2->disp;
 #endif
@@ -1282,72 +1548,18 @@
     switch (cmd) {
 #ifdef __sparc__
     case FBIOGTYPE:
-	fbtyp.fb_type = FBTYPE_PCI_GENERIC;
-	fbtyp.fb_width = info->current_par.crtc.vxres;
-	fbtyp.fb_height = info->current_par.crtc.vyres;
-	fbtyp.fb_depth = info->current_par.crtc.bpp;
-	fbtyp.fb_cmsize = disp->cmap.len;
-	fbtyp.fb_size = info->total_vram;
-	if (copy_to_user((struct fbtype *)arg, &fbtyp, sizeof(fbtyp)))
-		return -EFAULT;
-	break;
+        fbtyp.fb_type = FBTYPE_PCI_GENERIC;
+        fbtyp.fb_width = info->current_par.crtc.vxres;
+        fbtyp.fb_height = info->current_par.crtc.vyres;
+        fbtyp.fb_depth = info->current_par.crtc.bpp;
+        fbtyp.fb_cmsize = disp->cmap.len;
+        fbtyp.fb_size = info->total_vram;
+        if (copy_to_user((struct fbtype *)arg, &fbtyp, sizeof(fbtyp)))
+                return -EFAULT;
+        break;
 #endif /* __sparc__ */
-#if defined(DEBUG) && defined(CONFIG_FB_ATY_CT)
-    case ATYIO_CLKR:
-	if (M64_HAS(INTEGRATED)) {
-	    struct atyclk clk;
-	    union aty_pll *pll = &info->current_par.pll;
-	    u32 dsp_config = pll->ct.dsp_config;
-	    u32 dsp_on_off = pll->ct.dsp_on_off;
-	    clk.ref_clk_per = info->ref_clk_per;
-	    clk.pll_ref_div = pll->ct.pll_ref_div;
-	    clk.mclk_fb_div = pll->ct.mclk_fb_div;
-	    clk.mclk_post_div = pll->ct.mclk_post_div_real;
-	    clk.vclk_fb_div = pll->ct.vclk_fb_div;
-	    clk.vclk_post_div = pll->ct.vclk_post_div_real;
-	    clk.dsp_xclks_per_row = dsp_config & 0x3fff;
-	    clk.dsp_loop_latency = (dsp_config>>16) & 0xf;
-	    clk.dsp_precision = (dsp_config>>20) & 7;
-	    clk.dsp_on = dsp_on_off & 0x7ff;
-	    clk.dsp_off = (dsp_on_off>>16) & 0x7ff;
-	    if (copy_to_user((struct atyclk *)arg, &clk, sizeof(clk)))
-		    return -EFAULT;
-	} else
-	    return -EINVAL;
-	break;
-    case ATYIO_CLKW:
-	if (M64_HAS(INTEGRATED)) {
-	    struct atyclk clk;
-	    union aty_pll *pll = &info->current_par.pll;
-	    if (copy_from_user(&clk, (struct atyclk *)arg, sizeof(clk)))
-		    return -EFAULT;
-	    info->ref_clk_per = clk.ref_clk_per;
-	    pll->ct.pll_ref_div = clk.pll_ref_div;
-	    pll->ct.mclk_fb_div = clk.mclk_fb_div;
-	    pll->ct.mclk_post_div_real = clk.mclk_post_div;
-	    pll->ct.vclk_fb_div = clk.vclk_fb_div;
-	    pll->ct.vclk_post_div_real = clk.vclk_post_div;
-	    pll->ct.dsp_config = (clk.dsp_xclks_per_row & 0x3fff) |
-				 ((clk.dsp_loop_latency & 0xf)<<16) |
-				 ((clk.dsp_precision & 7)<<20);
-	    pll->ct.dsp_on_off = (clk.dsp_on & 0x7ff) |
-				 ((clk.dsp_off & 0x7ff)<<16);
-	    aty_calc_pll_ct(info, &pll->ct);
-	    aty_set_pll_ct(info, pll);
-	} else
-	    return -EINVAL;
-	break;
-    case ATYIO_FEATR:
-	if (get_user(info->features, (u32 *)arg))
-	    return -EFAULT;
-	break;
-    case ATYIO_FEATW:
-	if (put_user(info->features, (u32 *)arg))
-	    return -EFAULT;
-	break;
-#endif /* DEBUG && CONFIG_FB_ATY_CT */
     default:
-	return -EINVAL;
+        return -EINVAL;
     }
     return 0;
 }
@@ -1357,148 +1569,148 @@
     struct fb_info_aty *fb = (struct fb_info_aty *)info;
 
     if (fb->blitter_may_be_busy)
-	wait_for_idle(fb);
+        wait_for_idle(fb);
     return 0;
 }
 
 #ifdef __sparc__
 static int atyfb_mmap(struct fb_info *info, struct file *file,
-		      struct vm_area_struct *vma)
+                      struct vm_area_struct *vma)
 {
-	struct fb_info_aty *fb = (struct fb_info_aty *)info;
-	unsigned int size, page, map_size = 0;
-	unsigned long map_offset = 0;
-	unsigned long off;
-	int i;
-
-	if (!fb->mmap_map)
-		return -ENXIO;
-
-	if (vma->vm_pgoff > (~0UL >> PAGE_SHIFT))
-		return -EINVAL;
-
-	off = vma->vm_pgoff << PAGE_SHIFT;
-	size = vma->vm_end - vma->vm_start;
-
-	/* To stop the swapper from even considering these pages. */
-	vma->vm_flags |= (VM_SHM | VM_LOCKED);
-
-	if (((vma->vm_pgoff == 0) && (size == fb->total_vram)) ||
-	    ((off == fb->total_vram) && (size == PAGE_SIZE)))
-		off += 0x8000000000000000UL;
-
-	vma->vm_pgoff = off >> PAGE_SHIFT;	/* propagate off changes */
-
-	/* Each page, see which map applies */
-	for (page = 0; page < size; ) {
-		map_size = 0;
-		for (i = 0; fb->mmap_map[i].size; i++) {
-			unsigned long start = fb->mmap_map[i].voff;
-			unsigned long end = start + fb->mmap_map[i].size;
-			unsigned long offset = off + page;
-
-			if (start > offset)
-				continue;
-			if (offset >= end)
-				continue;
-
-			map_size = fb->mmap_map[i].size - (offset - start);
-			map_offset = fb->mmap_map[i].poff + (offset - start);
-			break;
-		}
-		if (!map_size) {
-			page += PAGE_SIZE;
-			continue;
-		}
-		if (page + map_size > size)
-			map_size = size - page;
-
-		pgprot_val(vma->vm_page_prot) &= ~(fb->mmap_map[i].prot_mask);
-		pgprot_val(vma->vm_page_prot) |= fb->mmap_map[i].prot_flag;
-
-		if (remap_page_range(vma->vm_start + page, map_offset,
-				     map_size, vma->vm_page_prot))
-			return -EAGAIN;
-
-		page += map_size;
-	}
-
-	if (!map_size)
-		return -EINVAL;
-
-	vma->vm_flags |= VM_IO;
-
-	if (!fb->mmaped) {
-		int lastconsole = 0;
-
-		if (info->display_fg)
-			lastconsole = info->display_fg->vc_num;
-		fb->mmaped = 1;
-		if (fb->consolecnt && fb_display[lastconsole].fb_info == info) {
-			fb->vtconsole = lastconsole;
-			vt_cons[lastconsole]->vc_mode = KD_GRAPHICS;
-		}
-	}
-	return 0;
+        struct fb_info_aty *fb = (struct fb_info_aty *)info;
+        unsigned int size, page, map_size = 0;
+        unsigned long map_offset = 0;
+        unsigned long off;
+        int i;
+
+        if (!fb->mmap_map)
+                return -ENXIO;
+
+        if (vma->vm_pgoff > (~0UL >> PAGE_SHIFT))
+                return -EINVAL;
+
+        off = vma->vm_pgoff << PAGE_SHIFT;
+        size = vma->vm_end - vma->vm_start;
+
+        /* To stop the swapper from even considering these pages. */
+        vma->vm_flags |= (VM_SHM | VM_LOCKED);
+
+        if (((vma->vm_pgoff == 0) && (size == fb->total_vram)) ||
+            ((off == fb->total_vram) && (size == PAGE_SIZE)))
+                off += 0x8000000000000000UL;
+
+        vma->vm_pgoff = off >> PAGE_SHIFT;      /* propagate off changes */
+
+        /* Each page, see which map applies */
+        for (page = 0; page < size; ) {
+                map_size = 0;
+                for (i = 0; fb->mmap_map[i].size; i++) {
+                        unsigned long start = fb->mmap_map[i].voff;
+                        unsigned long end = start + fb->mmap_map[i].size;
+                        unsigned long offset = off + page;
+
+                        if (start > offset)
+                                continue;
+                        if (offset >= end)
+                                continue;
+
+                        map_size = fb->mmap_map[i].size - (offset - start);
+                        map_offset = fb->mmap_map[i].poff + (offset - start);
+                        break;
+                }
+                if (!map_size) {
+                        page += PAGE_SIZE;
+                        continue;
+                }
+                if (page + map_size > size)
+                        map_size = size - page;
+
+                pgprot_val(vma->vm_page_prot) &= ~(fb->mmap_map[i].prot_mask);
+                pgprot_val(vma->vm_page_prot) |= fb->mmap_map[i].prot_flag;
+
+                if (remap_page_range(vma->vm_start + page, map_offset,
+                                     map_size, vma->vm_page_prot))
+                        return -EAGAIN;
+
+                page += map_size;
+        }
+
+        if (!map_size)
+                return -EINVAL;
+
+        vma->vm_flags |= VM_IO;
+
+        if (!fb->mmaped) {
+                int lastconsole = 0;
+
+                if (info->display_fg)
+                        lastconsole = info->display_fg->vc_num;
+                fb->mmaped = 1;
+                if (fb->consolecnt && fb_display[lastconsole].fb_info == info) {
+                        fb->vtconsole = lastconsole;
+                        vt_cons[lastconsole]->vc_mode = KD_GRAPHICS;
+                }
+        }
+        return 0;
 }
 
 static struct {
-	u32	yoffset;
-	u8	r[2][256];
-	u8	g[2][256];
-	u8	b[2][256];
+        u32     yoffset;
+        u8      r[2][256];
+        u8      g[2][256];
+        u8      b[2][256];
 } atyfb_save;
 
 static void atyfb_save_palette(struct fb_info *fb, int enter)
 {
-	struct fb_info_aty *info = (struct fb_info_aty *)fb;
-	int i, tmp;
+        struct fb_info_aty *info = (struct fb_info_aty *)fb;
+        int i, tmp;
 
-	for (i = 0; i < 256; i++) {
-		tmp = aty_ld_8(DAC_CNTL, info) & 0xfc;
-		if (M64_HAS(EXTRA_BRIGHT))
-			tmp |= 0x2;
-		aty_st_8(DAC_CNTL, tmp, info);
-		aty_st_8(DAC_MASK, 0xff, info);
-
-		writeb(i, &info->aty_cmap_regs->rindex);
-		atyfb_save.r[enter][i] = readb(&info->aty_cmap_regs->lut);
-		atyfb_save.g[enter][i] = readb(&info->aty_cmap_regs->lut);
-		atyfb_save.b[enter][i] = readb(&info->aty_cmap_regs->lut);
-		writeb(i, &info->aty_cmap_regs->windex);
-		writeb(atyfb_save.r[1-enter][i], &info->aty_cmap_regs->lut);
-		writeb(atyfb_save.g[1-enter][i], &info->aty_cmap_regs->lut);
-		writeb(atyfb_save.b[1-enter][i], &info->aty_cmap_regs->lut);
-	}
+        for (i = 0; i < 256; i++) {
+                tmp = aty_ld_8(DAC_CNTL, info) & 0xfc;
+                if (M64_HAS(EXTRA_BRIGHT))
+                        tmp |= 0x2;
+                aty_st_8(DAC_CNTL, tmp, info);
+                aty_st_8(DAC_MASK, 0xff, info);
+
+                writeb(i, &info->aty_cmap_regs->rindex);
+                atyfb_save.r[enter][i] = readb(&info->aty_cmap_regs->lut);
+                atyfb_save.g[enter][i] = readb(&info->aty_cmap_regs->lut);
+                atyfb_save.b[enter][i] = readb(&info->aty_cmap_regs->lut);
+                writeb(i, &info->aty_cmap_regs->windex);
+                writeb(atyfb_save.r[1-enter][i], &info->aty_cmap_regs->lut);
+                writeb(atyfb_save.g[1-enter][i], &info->aty_cmap_regs->lut);
+                writeb(atyfb_save.b[1-enter][i], &info->aty_cmap_regs->lut);
+        }
 }
 
 static void atyfb_palette(int enter)
 {
-	struct fb_info_aty *info;
-	struct atyfb_par *par;
-	struct display *d;
-	int i;
-
-	for (i = 0; i < MAX_NR_CONSOLES; i++) {
-		d = &fb_display[i];
-		if (d->fb_info &&
-		    d->fb_info->fbops == &atyfb_ops &&
-		    d->fb_info->display_fg &&
-		    d->fb_info->display_fg->vc_num == i) {
-			atyfb_save_palette(d->fb_info, enter);
-			info = (struct fb_info_aty *)d->fb_info;
-			par = &info->current_par;
-			if (enter) {
-				atyfb_save.yoffset = par->crtc.yoffset;
-				par->crtc.yoffset = 0;
-				set_off_pitch(par, info);
-			} else {
-				par->crtc.yoffset = atyfb_save.yoffset;
-				set_off_pitch(par, info);
-			}
-			break;
-		}
-	}
+        struct fb_info_aty *info;
+        struct atyfb_par *par;
+        struct display *d;
+        int i;
+
+        for (i = 0; i < MAX_NR_CONSOLES; i++) {
+                d = &fb_display[i];
+                if (d->fb_info &&
+                    d->fb_info->fbops == &atyfb_ops &&
+                    d->fb_info->display_fg &&
+                    d->fb_info->display_fg->vc_num == i) {
+                        atyfb_save_palette(d->fb_info, enter);
+                        info = (struct fb_info_aty *)d->fb_info;
+                        par = &info->current_par;
+                        if (enter) {
+                                atyfb_save.yoffset = par->crtc.yoffset;
+                                par->crtc.yoffset = 0;
+                                set_off_pitch(par, info);
+                        } else {
+                                par->crtc.yoffset = atyfb_save.yoffset;
+                                set_off_pitch(par, info);
+                        }
+                        break;
+                }
+        }
 }
 #endif /* __sparc__ */
 
